///////////////////
#include <OLED_I2C.h>
OLED  myOLED(SDA, SCL);// А4,A5
#define disp_1 6 // управляющие дисплееями выводы 
#define disp_2 5
#define disp_3 4
const char blBlock[8] PROGMEM={0,0,0,0,0,0,0,0};
const char block1[8]PROGMEM={0X7F,0X7F,0X63,0X63,0X63,0X7F,0X7F,0X00};//1 форма "живой клетки"
const char block2[8]PROGMEM={0X41,0X22,0X14,0X08,0X14,0X22,0X41,0X00};//2 форма "живой клетки"
const char block3[8]PROGMEM={0X08,0X08,0X14,0X63,0X14,0X08,0X08,0X00};//3 форма "живой клетки"
#define X 34  /* 34 maximum */
#define Y 10  /* 10 maximum */
bool state[X][Y], old[X][Y];
int state_K=0;// переменная хранения числа совпадений клеток предыдущего и текущего поколений (256 - полное совпадение, изчезновение или "замирание клеток")
int state_G=0;// переменная хранения числа живых клеток в поколении
int forma_=1;//
int N=0;// число жизненных циклов

extern uint8_t SmallFont[];
extern uint8_t MediumNumbers[];

void setup()
{
 myOLED.begin();
 myOLED.invert(0);//инверсия цвета
pinMode(disp_1, OUTPUT);pinMode(disp_2, OUTPUT);pinMode(disp_3, OUTPUT);

for(int i=0;i<analogRead(A0)/1;i++){ state[random(0,X)][random(0,Y)] = 1; forma_=i%3+1;}//псевдослучайное начальное заполнение массива "живыми клетками" с выбором их формы
  prnt();
  delay (1000);
}
void loop()
{
 ///////////////////
  if(state_K==256){delay(3000);pinMode(2,OUTPUT);}////(вывод 2 соединён с RES) перезагрузка платы - обновление жизни
  ///////////////////
  delay(120); 
  
  play();
  prnt();
  N++;//
 myOLED.setFont(SmallFont );myOLED.print("CYCLE", 0, 5);myOLED.print("SAME", 0, 25);myOLED.print("ALIVE", 0, 45);//число циклов, число совпадений в соседних поколениях, число живых в поколении  
 myOLED.setFont( MediumNumbers); myOLED.printNumI(N,55,5); myOLED.printNumI(state_K,55,25);myOLED.printNumI(state_G,55,45); dis_3();
   
}
///////////
void dis_1() { //функции обновления изображений на экранах
 pinMode(disp_1, INPUT); myOLED.update();pinMode(disp_1, OUTPUT);myOLED.clrScr(); // очищаем дисплей 
}
void dis_2() {
 pinMode(disp_2, INPUT); myOLED.update();pinMode(disp_2, OUTPUT);myOLED.clrScr(); // очищаем дисплей   
}
void dis_3() {
  pinMode(disp_3, INPUT); myOLED.update();pinMode(disp_3, OUTPUT);myOLED.clrScr(); // очищаем дисплей 
}
//////////////////////////////////////////////
void prnt () {
  for (int y = 1; y < Y - 1; y++) {
    for (int x = 1; x < 18 - 1; x++) {
      if (state[x][y]) {
        if(forma_==1){ myOLED.drawBitmap(0+(x-1)*8, 0+(y-1)*8,block1 , 8, 8); }
        if(forma_==2){ myOLED.drawBitmap(0+(x-1)*8, 0+(y-1)*8,block2 , 8, 8); }
        if(forma_==3){ myOLED.drawBitmap(0+(x-1)*8, 0+(y-1)*8,block3 , 8, 8); }
      }
      else {
       myOLED.drawBitmap(0+(x-1)*8, 0+(y-1)*8,blBlock , 8, 8); 
      }
    }
   }
  dis_1();  
  ///////////
  for (int y = 1; y < Y - 1; y++) {
    for (int x = 17; x < X - 1; x++) {
      if (state[x][y]) {
        if(forma_==1){ myOLED.drawBitmap(0+(x-1-16)*8, 0+(y-1)*8,block1 , 8, 8); }
        if(forma_==2){ myOLED.drawBitmap(0+(x-1-16)*8, 0+(y-1)*8,block2 , 8, 8); }
        if(forma_==3){ myOLED.drawBitmap(0+(x-1-16)*8, 0+(y-1)*8,block3 , 8, 8); }
      }
      else {
       myOLED.drawBitmap(0+(x-1-16)*8, 0+(y-1)*8,blBlock , 8, 8); 
      }
    }
   }
  dis_2();  
}
///////////////////////////////////////////////
void play() {
  state_K=0;
  state_G=0;
  for (int x = 1; x < X - 1; x++) {
    for (int y = 1; y < Y - 1; y++) {
      old[x][y] = state[x][y];
      state[x][y] = 0;
    }
  }
  for (int x = 1; x < X - 1; x++) {
    for (int y = 1; y < Y - 1; y++) {
      if ((old[x][y + 1] + old[x][y - 1] + old[x + 1][y] + old[x - 1][y] + old[x + 1][y + 1] + old[x - 1][y - 1] + old[x + 1][y - 1] + old[x - 1][y + 1])==3|| // изменённый вариант условий игры "жизнь"
     (old[x][y + 1] + old[x][y - 1] + old[x + 1][y] + old[x - 1][y] + old[x + 1][y + 1] + old[x - 1][y - 1] + old[x + 1][y - 1] + old[x - 1][y + 1]+old[x][y])==3||
     (old[x][y + 1] + old[x][y - 1] + old[x + 1][y] + old[x - 1][y] + old[x + 1][y + 1] + old[x - 1][y - 1] + old[x + 1][y - 1] + old[x - 1][y + 1]+old[x][y])==4) {
       
       state[x][y] = 1;state_G++;
       
      }
    if(old[x][y] == state[x][y]){state_K++;}// если клетки соседних поколений совпали
    }
  }
}
//////////////////////////////////////////////

